#
# Copyright (c) 2012 Thierry Florac <tflorac AT onf.fr>
# All Rights Reserved.
#


# import standard packages

# import Zope3 interfaces

# import packages
from pyams_alchemy import Base
from onf_website.reference.forest.model import PARENT_SCHEMA, PARENT_SESSION
from pyams_alchemy.engine import get_user_session
from pyams_alchemy.mixin import DynamicSchemaMixin
from sqlalchemy.schema import ForeignKey, PrimaryKeyConstraint
from sqlalchemy import Column, Integer, Unicode, Date
from sqlalchemy.ext.declarative import declared_attr
from sqlalchemy.sql import and_

from onf_website import _


# Table IFN_CODE


class Code(DynamicSchemaMixin, Base):
    """Model class for IFN_CODE table"""

    __tablename__ = 'rdf_typo'
    __schema__ = PARENT_SCHEMA

    @declared_attr
    def __table_args__(cls):
        return (
            PrimaryKeyConstraint('unite', 'code'),
            cls.get_schema()
        )

    unite = Column(Unicode)
    code = Column(Unicode)
    libelle = Column(Unicode)


def get_libelle(unite, code, session=PARENT_SESSION):
    """Extract label for given code and unit"""
    session = get_user_session(session)
    try:
        return session.query(Code).filter(and_(Code.unite == unite,
                                               Code.code == code)).first().libelle
    except:
        return _("< missing reference label >")
